com.io7m.jregions.core.unparameterized.areas

## Class AreasL

- java.lang.Object
- - com.io7m.jregions.core.unparameterized.areas.AreasL

-     public final class AreasL
      extends Object

  Functions over areas.

  These functions operate using the concepts of minimum-x, maximum-x, minimum-y, and maximum-y edges. It is up to individual applications to assign meaning to these edges such as "left" for minimum-x and "top" for minimum-y.

- - ### Method Summary

    All Methods Static Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `static AreaL` | `alignCenter(AreaL outer, AreaL inner)` Align the area `inner` such that the center of the area is equal to the center of `outer`.
    `static AreaL` | `alignHorizontallyCenter(AreaL outer, AreaL inner)` Deprecated. Use `alignOnXCenter(AreaL, AreaL)`
    `static AreaL` | `alignHorizontallyMaxX(AreaL outer, AreaL inner)` Deprecated. Use `alignOnXMaxX(AreaL, AreaL)`
    `static AreaL` | `alignHorizontallyMaxXOffset(AreaL outer, AreaL inner, long offset)` Deprecated. Use `alignOnXMaxXOffset(AreaL, AreaL, long)`
    `static AreaL` | `alignHorizontallyMinX(AreaL outer, AreaL inner)` Deprecated. Use `alignOnXMinX(AreaL, AreaL)`
    `static AreaL` | `alignHorizontallyMinXOffset(AreaL outer, AreaL inner, long offset)` Deprecated. Use `alignOnXMinXOffset(AreaL, AreaL, long)`
    `static AreaL` | `alignMaxYMaxX(AreaL outer, AreaL inner)` Equivalent to calling `alignMaxYMaxXOffset(AreaL, AreaL, long, long)` with zero offsets.
    `static AreaL` | `alignMaxYMaxXOffset(AreaL outer, AreaL inner, long offset_x, long offset_y)` Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static AreaL` | `alignMaxYMinX(AreaL outer, AreaL inner)` Equivalent to calling `alignMaxYMinXOffset(AreaL, AreaL, long, long)` with zero offsets.
    `static AreaL` | `alignMaxYMinXOffset(AreaL outer, AreaL inner, long offset_x, long offset_y)` Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static AreaL` | `alignMinYMaxX(AreaL outer, AreaL inner)` Equivalent to calling `alignMinYMaxXOffset(AreaL, AreaL, long, long)` with zero offsets.
    `static AreaL` | `alignMinYMaxXOffset(AreaL outer, AreaL inner, long offset_x, long offset_y)` Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
    `static AreaL` | `alignMinYMinX(AreaL outer, AreaL inner)` Equivalent to calling `alignMinYMinXOffset(AreaL, AreaL, long, long)` with zero offsets.
    `static AreaL` | `alignMinYMinXOffset(AreaL outer, AreaL inner, long offset_x, long offset_y)` Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
    `static AreaL` | `alignOnXCenter(AreaL outer, AreaL inner)` Align the area `inner` along the X axis in the center of `outer`.
    `static AreaL` | `alignOnXMaxX(AreaL outer, AreaL inner)` Equivalent to calling `alignOnXMaxXOffset(AreaL, AreaL, long)` with a zero offset.
    `static AreaL` | `alignOnXMaxXOffset(AreaL outer, AreaL inner, long offset)` Align the area `inner` along the X axis against the inside maximum-x edge of `outer`.
    `static AreaL` | `alignOnXMinX(AreaL outer, AreaL inner)` Equivalent to calling `alignOnXMinXOffset(AreaL, AreaL, long)` with a zero offset.
    `static AreaL` | `alignOnXMinXOffset(AreaL outer, AreaL inner, long offset)` Align the area `inner` along the X axis against the inside minimum-x edge of `outer`.
    `static AreaL` | `alignOnYCenter(AreaL outer, AreaL inner)` Align the area `inner` along the Y axis in the center of `outer`.
    `static AreaL` | `alignOnYMaxY(AreaL outer, AreaL inner)` Equivalent to calling `alignOnYMaxYOffset(AreaL, AreaL, long)` with a zero offset.
    `static AreaL` | `alignOnYMaxYOffset(AreaL outer, AreaL inner, long offset)` Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`.
    `static AreaL` | `alignOnYMinY(AreaL outer, AreaL inner)` Equivalent to calling `alignOnYMinYOffset(AreaL, AreaL, long)` with a zero offset.
    `static AreaL` | `alignOnYMinYOffset(AreaL outer, AreaL inner, long offset)` Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`.
    `static AreaL` | `alignVerticallyCenter(AreaL outer, AreaL inner)` Deprecated. Use `alignOnYCenter(AreaL, AreaL)`
    `static AreaL` | `alignVerticallyMaxY(AreaL outer, AreaL inner)` Deprecated. Use `alignOnYMaxY(AreaL, AreaL)`
    `static AreaL` | `alignVerticallyMaxYOffset(AreaL outer, AreaL inner, long offset)` Deprecated. Use `alignOnYMaxYOffset(AreaL, AreaL, long)`
    `static AreaL` | `alignVerticallyMinY(AreaL outer, AreaL inner)` Deprecated. Use `alignOnYMinY(AreaL, AreaL)`
    `static AreaL` | `alignVerticallyMinYOffset(AreaL outer, AreaL inner, long offset)` Deprecated. Use `alignOnYMinYOffset(AreaL, AreaL, long)`
    `static AreaL` | `containing(AreaL a, AreaL b)` Construct a area that will contain both `a` and `b`.
    `static boolean` | `contains(AreaL a, AreaL b)` Determine whether or not one area contains another.
    `static boolean` | `containsPoint(AreaL a, long x, long y)` Determine whether or not a area contains a given point.
    `static boolean` | `couldFitInside(AreaL a, AreaL b)` Determine whether or not one area could fit inside another.
    `static AreaL` | `create(long x, long y, long size_x, long size_y)` Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
    `static AreaL` | `fitBetweenHorizontal(AreaL fit, AreaL a, AreaL b)` Deprecated. Use `fitBetweenOnX(AreaL, AreaL, AreaL)`
    `static AreaL` | `fitBetweenOnX(AreaL fit, AreaL a, AreaL b)` Attempt to fit `fit` between `a` and `b`, horizontally.
    `static AreaL` | `fitBetweenOnY(AreaL fit, AreaL a, AreaL b)` Attempt to fit `fit` between `a` and `b`, vertically.
    `static AreaL` | `fitBetweenVertical(AreaL fit, AreaL a, AreaL b)` Deprecated. Use `fitBetweenOnY(AreaL, AreaL, AreaL)`
    `static AreaL` | `hollowOut(AreaL outer, long min_x_offset, long max_x_offset, long min_y_offset, long max_y_offset)` Construct a new area that fits inside `outer` based on the given offsets from each edge.
    `static AreaL` | `hollowOutEvenly(AreaL outer, long offset)` Equivalent to calling `hollowOut(AreaL, long, long, long, long)` with `offset` for all offset parameters.
    `static AreaL` | `moveAbsolute(AreaL area, long x, long y)` Move the given area to `(x, y)`.
    `static AreaL` | `moveRelative(AreaL area, long x, long y)` Move the given area by `(x, y)`.
    `static AreaL` | `moveToOrigin(AreaL area)` Move the given area to `(0, 0)`.
    `static boolean` | `overlaps(AreaL a, AreaL b)` Determine whether or not two areas overlap.
    `static AreaL` | `scaleFromCenter(AreaL area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaL` | `scaleFromMaxYMaxX(AreaL area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaL` | `scaleFromMaxYMinX(AreaL area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaL` | `scaleFromMinYMaxX(AreaL area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaL` | `scaleFromMinYMinX(AreaL area, long x_diff, long y_diff)` Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY.
    `static AreaL` | `setSizeFromCenter(AreaL area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaL` | `setSizeFromMaxYMaxX(AreaL area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaL` | `setSizeFromMaxYMinX(AreaL area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaL` | `setSizeFromMinYMaxX(AreaL area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static AreaL` | `setSizeFromMinYMinX(AreaL area, long sizeX, long sizeY)` Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.
    `static String` | `show(AreaL area)`
    `static String` | `showToBuilder(AreaL area, StringBuilder sb)`
    `static AreaSizeL` | `size(AreaL area)`
    `static AreaXSplitL<AreaL>` | `splitAlongParallelToX(AreaL area, long y)` Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
    `static AreaYSplitL<AreaL>` | `splitAlongParallelToY(AreaL area, long x)` Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
    `static AreaXYSplitL<AreaL>` | `splitAlongXY(AreaL area, long x, long y)` Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static AreaL create(long x,
                                     long y,
                                     long size_x,
                                     long size_y)

      Create an area of size `size_x` on the X axis and size `size_y` on the Y axis, placing the minimum corner at `(x, y)`.
      Parameters:
        `x` - The X value of the minimum corner
        `y` - The Y value of the minimum corner
        `size_x` - The size of the area on the X axis
        `size_y` - The size of the area on the Y axis
      Returns:
        An area

    - #### contains

          public static boolean contains(AreaL a,
                                         AreaL b)

      Determine whether or not one area contains another.

      Containing is reflexive: `contains(a, a) == true`.

      Containing is transitive: `contains(a, b) → contains(b, c) → contains(a, c)`.

      Containing is not necessarily symmetric.

      Parameters:
        `a` - Area A
        `b` - Area B
      Returns:
        `true` iff `a` contains `b`

    - #### moveRelative

          public static AreaL moveRelative(AreaL area,
                                           long x,
                                           long y)

      Move the given area by `(x, y)`.
      Parameters:
        `area` - The area
        `x` - The amount to move on the X axis
        `y` - The amount to move on the Y axis
      Returns:
        A moved area

    - #### moveAbsolute

          public static AreaL moveAbsolute(AreaL area,
                                           long x,
                                           long y)

      Move the given area to `(x, y)`.
      Parameters:
        `area` - The area
        `x` - The position to which to move on the X axis
        `y` - The position to which to move on the Y axis
      Returns:
        A moved area

    - #### moveToOrigin

          public static AreaL moveToOrigin(AreaL area)

      Move the given area to `(0, 0)`.
      Parameters:
        `area` - The area
      Returns:
        A moved area

    - #### alignOnXCenter

          public static AreaL alignOnXCenter(AreaL outer,
                                             AreaL inner)

      Align the area `inner` along the X axis in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinX

          public static AreaL alignOnXMinX(AreaL outer,
                                           AreaL inner)

      Equivalent to calling `alignOnXMinXOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMinXOffset

          public static AreaL alignOnXMinXOffset(AreaL outer,
                                                 AreaL inner,
                                                 long offset)

      Align the area `inner` along the X axis against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxX

          public static AreaL alignOnXMaxX(AreaL outer,
                                           AreaL inner)

      Equivalent to calling `alignOnXMaxXOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnXMaxXOffset

          public static AreaL alignOnXMaxXOffset(AreaL outer,
                                                 AreaL inner,
                                                 long offset)

      Align the area `inner` along the X axis against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinY

          public static AreaL alignOnYMinY(AreaL outer,
                                           AreaL inner)

      Equivalent to calling `alignOnYMinYOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMinYOffset

          public static AreaL alignOnYMinYOffset(AreaL outer,
                                                 AreaL inner,
                                                 long offset)

      Align the area `inner` along the Y axis against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxY

          public static AreaL alignOnYMaxY(AreaL outer,
                                           AreaL inner)

      Equivalent to calling `alignOnYMaxYOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYMaxYOffset

          public static AreaL alignOnYMaxYOffset(AreaL outer,
                                                 AreaL inner,
                                                 long offset)

      Align the area `inner` along the Y axis against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignOnYCenter

          public static AreaL alignOnYCenter(AreaL outer,
                                             AreaL inner)

      Align the area `inner` along the Y axis in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area
      Since:
        1.1.0

    - #### alignHorizontallyCenter

          @Deprecated
          public static AreaL alignHorizontallyCenter(AreaL outer,
                                                                  AreaL inner)

      Deprecated. Use `alignOnXCenter(AreaL, AreaL)`
      Align the area `inner` horizontally in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinX

          @Deprecated
          public static AreaL alignHorizontallyMinX(AreaL outer,
                                                                AreaL inner)

      Deprecated. Use `alignOnXMinX(AreaL, AreaL)`
      Equivalent to calling `alignHorizontallyMinXOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMinXOffset

          @Deprecated
          public static AreaL alignHorizontallyMinXOffset(AreaL outer,
                                                                      AreaL inner,
                                                                      long offset)

      Deprecated. Use `alignOnXMinXOffset(AreaL, AreaL, long)`
      Align the area `inner` horizontally against the inside minimum-x edge of `outer`. The area will be at least `offset` units from the minimum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignHorizontallyMaxX

          @Deprecated
          public static AreaL alignHorizontallyMaxX(AreaL outer,
                                                                AreaL inner)

      Deprecated. Use `alignOnXMaxX(AreaL, AreaL)`
      Equivalent to calling `alignHorizontallyMaxXOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignHorizontallyMaxXOffset

          @Deprecated
          public static AreaL alignHorizontallyMaxXOffset(AreaL outer,
                                                                      AreaL inner,
                                                                      long offset)

      Deprecated. Use `alignOnXMaxXOffset(AreaL, AreaL, long)`
      Align the area `inner` horizontally against the inside maximum-x edge of `outer`. The area will be at least `offset` units from the maximum-x edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMinY

          @Deprecated
          public static AreaL alignVerticallyMinY(AreaL outer,
                                                              AreaL inner)

      Deprecated. Use `alignOnYMinY(AreaL, AreaL)`
      Equivalent to calling `alignVerticallyMinYOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMinYOffset

          @Deprecated
          public static AreaL alignVerticallyMinYOffset(AreaL outer,
                                                                    AreaL inner,
                                                                    long offset)

      Deprecated. Use `alignOnYMinYOffset(AreaL, AreaL, long)`
      Align the area `inner` vertically against the inside minimum-y edge of `outer`. The area will be at least `offset` units from the minimum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyMaxY

          @Deprecated
          public static AreaL alignVerticallyMaxY(AreaL outer,
                                                              AreaL inner)

      Deprecated. Use `alignOnYMaxY(AreaL, AreaL)`
      Equivalent to calling `alignVerticallyMaxYOffset(AreaL, AreaL, long)` with a zero offset.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignVerticallyMaxYOffset

          @Deprecated
          public static AreaL alignVerticallyMaxYOffset(AreaL outer,
                                                                    AreaL inner,
                                                                    long offset)

      Deprecated. Use `alignOnYMaxYOffset(AreaL, AreaL, long)`
      Align the area `inner` vertically against the inside maximum-y edge of `outer`. The area will be at least `offset` units from the maximum-y edge.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset` - The offset from the edge
      Returns:
        An aligned area

    - #### alignVerticallyCenter

          @Deprecated
          public static AreaL alignVerticallyCenter(AreaL outer,
                                                                AreaL inner)

      Deprecated. Use `alignOnYCenter(AreaL, AreaL)`
      Align the area `inner` vertically in the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinX

          public static AreaL alignMinYMinX(AreaL outer,
                                            AreaL inner)

      Equivalent to calling `alignMinYMinXOffset(AreaL, AreaL, long, long)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMinXOffset

          public static AreaL alignMinYMinXOffset(AreaL outer,
                                                  AreaL inner,
                                                  long offset_x,
                                                  long offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMinYMaxX

          public static AreaL alignMinYMaxX(AreaL outer,
                                            AreaL inner)

      Equivalent to calling `alignMinYMaxXOffset(AreaL, AreaL, long, long)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMinYMaxXOffset

          public static AreaL alignMinYMaxXOffset(AreaL outer,
                                                  AreaL inner,
                                                  long offset_x,
                                                  long offset_y)

      Align the area `inner` such that the minimum-y edge is at least `offset_y` from the inside minimum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the minimum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMinX

          public static AreaL alignMaxYMinX(AreaL outer,
                                            AreaL inner)

      Equivalent to calling `alignMaxYMinXOffset(AreaL, AreaL, long, long)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMinXOffset

          public static AreaL alignMaxYMinXOffset(AreaL outer,
                                                  AreaL inner,
                                                  long offset_x,
                                                  long offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the minimum-x edge is at least `offset_x` from the inside minimum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the minimum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignMaxYMaxX

          public static AreaL alignMaxYMaxX(AreaL outer,
                                            AreaL inner)

      Equivalent to calling `alignMaxYMaxXOffset(AreaL, AreaL, long, long)` with zero offsets.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### alignMaxYMaxXOffset

          public static AreaL alignMaxYMaxXOffset(AreaL outer,
                                                  AreaL inner,
                                                  long offset_x,
                                                  long offset_y)

      Align the area `inner` such that the maximum-y edge is at least `offset_y` from the inside maximum-y edge of `outer` and the maximum-x edge is at least `offset_x` from the inside maximum-x edge of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
        `offset_x` - The offset from the maximum-x edge
        `offset_y` - The offset from the maximum-y edge
      Returns:
        An aligned area

    - #### alignCenter

          public static AreaL alignCenter(AreaL outer,
                                          AreaL inner)

      Align the area `inner` such that the center of the area is equal to the center of `outer`.
      Parameters:
        `outer` - The outer area
        `inner` - The inner area
      Returns:
        An aligned area

    - #### hollowOut

          public static AreaL hollowOut(AreaL outer,
                                        long min_x_offset,
                                        long max_x_offset,
                                        long min_y_offset,
                                        long max_y_offset)

      Construct a new area that fits inside `outer` based on the given offsets from each edge.
      Parameters:
        `outer` - The containing area
        `min_x_offset` - The offset from the minimum-x edge (must be non-negative)
        `max_x_offset` - The offset from the maximum-x edge (must be non-negative)
        `min_y_offset` - The offset from the minimum-y edge (must be non-negative)
        `max_y_offset` - The offset from the maximum-y edge (must be non-negative)
      Returns:
        A new area

    - #### hollowOutEvenly

          public static AreaL hollowOutEvenly(AreaL outer,
                                              long offset)

      Equivalent to calling `hollowOut(AreaL, long, long, long, long)` with `offset` for all offset parameters.
      Parameters:
        `outer` - The containing area
        `offset` - The offset from each edge (must be non-negative)
      Returns:
        A new area

    - #### setSizeFromCenter

          public static AreaL setSizeFromCenter(AreaL area,
                                                long sizeX,
                                                long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized from its own center.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMinX

          public static AreaL setSizeFromMinYMinX(AreaL area,
                                                  long sizeX,
                                                  long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMinYMaxX

          public static AreaL setSizeFromMinYMaxX(AreaL area,
                                                  long sizeX,
                                                  long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its minimum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMaxX

          public static AreaL setSizeFromMaxYMaxX(AreaL area,
                                                  long sizeX,
                                                  long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### setSizeFromMaxYMinX

          public static AreaL setSizeFromMaxYMinX(AreaL area,
                                                  long sizeX,
                                                  long sizeY)

      Set the sizeX and sizeY of `area` to `sizeX` and `sizeY`, respectively.

      The area is resized by moving its maximum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `sizeX` - The new sizeX (must be non-negative)
        `sizeY` - The new sizeY (must be non-negative)
      Returns:
        A resized area

    - #### scaleFromMinYMinX

          public static AreaL scaleFromMinYMinX(AreaL area,
                                                long x_diff,
                                                long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMinYMaxX

          public static AreaL scaleFromMinYMaxX(AreaL area,
                                                long x_diff,
                                                long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its minimum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMinX

          public static AreaL scaleFromMaxYMinX(AreaL area,
                                                long x_diff,
                                                long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-minimum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromMaxYMaxX

          public static AreaL scaleFromMaxYMaxX(AreaL area,
                                                long x_diff,
                                                long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized by moving its maximum-y-maximum-x corner.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### scaleFromCenter

          public static AreaL scaleFromCenter(AreaL area,
                                              long x_diff,
                                              long y_diff)

      Scale `area` by adding `x_diff` to the sizeX, and `y_diff` to the sizeY. The size of the resulting area is clamped so that its sizeX and sizeY are always non-negative.

      The area is resized from its own center.

      Parameters:
        `area` - The area
        `x_diff` - The X difference
        `y_diff` - The Y difference
      Returns:
        A resized area

    - #### overlaps

          public static boolean overlaps(AreaL a,
                                         AreaL b)

      Determine whether or not two areas overlap.

      Overlapping is reflexive: `overlaps(a, a) == true`.

      Overlapping is symmetric: `overlaps(a, b) == overlaps(b, a)`.

      Overlapping is not necessarily transitive.

      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` overlaps `b`

    - #### couldFitInside

          public static boolean couldFitInside(AreaL a,
                                               AreaL b)

      Determine whether or not one area could fit inside another.

      Fitting is reflexive: `couldFitInside(a, a) == true`.

      Fitting is transitive: `couldFitInside(a, b) → couldFitInside(b, c) → couldFitInside(a, c)`.

      Fitting is not necessarily symmetric.

      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        `true` iff `a` could fit inside `b`

    - #### containing

          public static AreaL containing(AreaL a,
                                         AreaL b)

      Construct a area that will contain both `a` and `b`.
      Parameters:
        `a` - An area
        `b` - An area
      Returns:
        An area containing `a` and `b`

    - #### containsPoint

          public static boolean containsPoint(AreaL a,
                                              long x,
                                              long y)

      Determine whether or not a area contains a given point.

      Parameters:
        `a` - An area
        `x` - The X coordinate of the point
        `y` - The Y coordinate of the point
      Returns:
        `true` iff `a` contains `(x, y)`

    - #### fitBetweenHorizontal

          @Deprecated
          public static AreaL fitBetweenHorizontal(AreaL fit,
                                                               AreaL a,
                                                               AreaL b)

      Deprecated. Use `fitBetweenOnX(AreaL, AreaL, AreaL)`
      Attempt to fit `fit` between `a` and `b`, horizontally.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenVertical

          @Deprecated
          public static AreaL fitBetweenVertical(AreaL fit,
                                                             AreaL a,
                                                             AreaL b)

      Deprecated. Use `fitBetweenOnY(AreaL, AreaL, AreaL)`
      Attempt to fit `fit` between `a` and `b`, vertically.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnX

          public static AreaL fitBetweenOnX(AreaL fit,
                                            AreaL a,
                                            AreaL b)

      Attempt to fit `fit` between `a` and `b`, horizontally.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### fitBetweenOnY

          public static AreaL fitBetweenOnY(AreaL fit,
                                            AreaL a,
                                            AreaL b)

      Attempt to fit `fit` between `a` and `b`, vertically.
      Parameters:
        `fit` - The area to be fitted
        `a` - An area
        `b` - An area
      Returns:
        A fitted area

    - #### splitAlongParallelToX

          public static AreaXSplitL<AreaL> splitAlongParallelToX(AreaL area,
                                                                 long y)

      Split `area` along a line parallel to the X axis placed at `y` units from its own minimum-y edge.
      Parameters:
        `area` - The area to be split
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongParallelToY

          public static AreaYSplitL<AreaL> splitAlongParallelToY(AreaL area,
                                                                 long x)

      Split `area` along a line parallel to the Y axis placed at `x` units from its own minimum-x edge.
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
      Returns:
        A pair of areas

    - #### splitAlongXY

          public static AreaXYSplitL<AreaL> splitAlongXY(AreaL area,
                                                         long x,
                                                         long y)

      Split `area` along a two axis-aligned perpendicular lines that intercept at `(x, y)`.
      Parameters:
        `area` - The area to be split
        `x` - The relative X coordinate of the splitting edge
        `y` - The relative Y coordinate of the splitting edge
      Returns:
        The four resulting quadrants
      Since:
        1.1.0

    - #### show

          public static String show(AreaL area)

      Parameters:
        `area` - The area
      Returns:
        A terse string describing the position and size of the area

    - #### size

          public static AreaSizeL size(AreaL area)

      Parameters:
        `area` - The area
      Returns:
        The size of the area

    - #### showToBuilder

          public static String showToBuilder(AreaL area,
                                             StringBuilder sb)

      Parameters:
        `area` - The area
        `sb` - A string builder
      Returns:
        A terse string describing the position and size of the area

Copyright © 2017 <code@io7m.com> http://io7m.com